import junit.framework.TestCase;

public class Homework02 extends TestCase {
  
  public void testAddDigitsToDisplay() {
    BasicAccumulator t = new BasicAccumulator();
    t.addDigit(7);
    assertEquals( 7, t.displayValue() );
    t.addDigit(8);
    assertEquals( 78, t.displayValue() );
    t.addDigit(9);
    assertEquals( 789, t.displayValue() );
  }
  
  public void testAddPositiveResult() {
    BasicAccumulator t = new BasicAccumulator();
    t.addDigit(1);
    t.addDigit(2);
    t.plus();
    assertEquals( 12, t.displayValue() );
    t.addDigit(5);
    t.addDigit(6);
    t.plus();
    assertEquals( 68, t.displayValue() );
  }
  
  public void testMinusPositiveResult() {
    BasicAccumulator t = new BasicAccumulator();
    t.addDigit(1);
    t.addDigit(2);
    t.plus();
    assertEquals( 12, t.displayValue() );
    t.addDigit(5);
    t.minus();
    assertEquals( 7, t.displayValue() );
  }
  
  public void testMinusNegativeResult() {
    BasicAccumulator t = new BasicAccumulator();
    t.addDigit(1);
    t.addDigit(2);
    t.plus();
    assertEquals( 12, t.displayValue() );
    t.addDigit(5);
    t.addDigit(9);
    t.minus();
    assertEquals( -47, t.displayValue() );
  }

  public void testPlusNegativeResult() {
    BasicAccumulator t = new BasicAccumulator();
    t.addDigit(1);
    t.addDigit(2);
    t.minus();
    assertEquals( -12, t.displayValue() );
    t.addDigit(5);
    t.plus();
    assertEquals( -7, t.displayValue() );
  }

  public void testClear() {
    BasicAccumulator t = new BasicAccumulator();
    t.addDigit(1);
    t.addDigit(2);
    t.minus();
    assertEquals( -12, t.displayValue() );
    t.addDigit(5);
    t.plus();
    t.clear();
    assertEquals( 0, t.displayValue() );
    t.addDigit(1);
    t.addDigit(2);
    t.plus();
    assertEquals( 12, t.displayValue() );
    t.addDigit(5);
    t.addDigit(6);
    t.plus();
    assertEquals( 68, t.displayValue() );
    t.clear();
    assertEquals( 0, t.displayValue() );
  }

  public void testSimpleClear() {
    BasicAccumulator t = new BasicAccumulator();
    t.addDigit(1);
    t.clear();
    assertEquals( 1, t.displayValue() );
  }

  public void testFail() {
    BasicAccumulator t = null;
    t.addDigit(1);
    fail( "Should be null pointer" );
  }
}
